/////////////////////////////////////////////////////////////////////
// WaitRedraw.cpp - class for flicker free drawing
//

#include "stdafx.h"
#include "obs.h"

int CWaitRedraw::m_nRedrawCount = 0;

CWaitRedraw::CWaitRedraw()
{
	CWnd * pMainWnd = AfxGetMainWnd();
	if (pMainWnd)
	{
		if (m_nRedrawCount == 0)
			pMainWnd->SetRedraw(FALSE);
		m_nRedrawCount++;
	}
}

CWaitRedraw::~CWaitRedraw()
{
	CWnd * pMainWnd = AfxGetMainWnd();
	if (pMainWnd)
	{
		if (m_nRedrawCount > 0)
			m_nRedrawCount--;
		if (m_nRedrawCount == 0)
		{
			pMainWnd->SetRedraw(TRUE);
			pMainWnd->Invalidate();
		}
	}
}

void CWaitRedraw::Restore()
{
	m_nRedrawCount = 0;
	CWnd * pMainWnd = AfxGetMainWnd();
	if (pMainWnd)
	{
		pMainWnd->SetRedraw(TRUE);
		pMainWnd->Invalidate();
	}
}
